工作日常问题10个

1.使用date作为乐观锁更新条件,有问题
之前,习惯使用“悲观锁”更新,select * from user where id = #{id} for update , update user set name = “a” where id = 1。
最近,尝试使用“乐观锁”更新,update user set name = "a" where id = 1 and updateTime = #{updateTime}。
在以下情况下:线上环境会有问题。
先add 1个User,再更新User,updateTime使用增加User对象中设置的updateTime,java的new Date()。
根据日志分析出,java传入的#{updateTime}和数据库中的updateTime比较不相等。


解决办法:增加int(11) version。
update user set name = "a",version=#{version} where id = 1 and version = #{oldVersion}。


2、jar包和JDK版本冲突。
增加一个合同导入功能,数据源是CSV格式。
找了一个csvreader的pom配置,本地开发测试通过。
线上发布的时候,出错,提示 unsupporter version。


错误原因:线上JDK是1.6版本,jar包需要JDK1.7。
A项目,用的是1.7。
又接手1个项目B,默认用1.7。


3.测试环境用户系统,突然找不到“使用了6个多月的用户A了”。
原因:用户系统,再进行清理,大量“离职用户”数据被清除,增加一批“新入职用户”。


4、公司内部,系统上线使用jone这个自动化部署工具。
好几次遇到,“找不到包A的类B”。
从服务器寻找A包,查找类B,下载下来,使用反编译工具,可以正常打开。
结论:包和类都没有问题。
原因:jone自身问题,过段时间再打包就好了。次数多了,发现1个规律:打包特别慢的时候,最终的war包部署时,出问题的可能性大很多。


5、并发场景,从无到有,代码就有问题了。
用户,预约1个健身房资源。人不来,产生违约记录。
处理违约记录的时候,先查找1个用户是否有“征信”记录,如果没有,就创建。
“征信”记录,违约次数+1更新成功和违约记录已处理,放在1个事务里。


  早先:增加1个定时任务,并且只让1台机器执行。
  后来:增加用户取消预约的功能,MQ消息是异步,多个MQ、定时任务,会产生原本没有“并发处理1个人的预约记录”。
  产生的问题:
  a.1个人的征信记录,创建了2(多)次。解决办法:appId,userId等,增加唯一索引。
  b.1个人有多条违约记录时,违约次数计算不正确。
  
6、Spring事务隔离级别默认为“Repeatable read (可重复读):可避免脏读、不可重复读的发生。”。
@Transactional
UserCredit getOrInit(User user){
  try{
     UserCredit userCredit=findById(id);
if(userCredit == null){
  newUserCredit=buildNewUserCredit();
  add(newUserCredit);
}
   
  }catch(DuplicateKeyException){
  // 再次查询1次(这个地方查询不到,可重复读)
userCredit=findById(id);


  }
  return userCredit;

参考资料:http://www.cnblogs.com/fjdingsd/p/5273008.html


7、MQ消息,如果有异常,最终需要抛出异常,让MQ下次重试。
  消息没有正常处理成功,及时抛出异常,下次重试。
  
8、京东主站登录,1小时之后,就需要再次登录。
8月份,京东主站升级之后,没有接入“公共头部”的系统,需要手动调用getJson("***"),刷新Cookie。
不然,会话有效时间只有1个小时。
咱们的系统,只使用jdpassport服务,没有引入公共头部。


9、分页bug。
执行查询A,跳转到第2页。输入查询条件B,执行查询B,pageNo仍然为2。
应改为1,每次查询,默认跳转到第1页。
  
  
黑名单查询bug,参数一样,查询结果不一样。后来发现,qq浏览器分页pageNo是2289。
最终发现,先查询1次,跳转到最后1页。再次查询,pageNo没有重置为1.




10、java maven项目找不到jconsole-1.8.0.jar和tools-1.8.0.jar包。
虽然遇到了这个情况,但是更有可能是Eclipse Maven工程环境出问题导致的。
下面的解决办法,可能并没有用。


alibaba 的druid所依赖的包:


<dependency>
        <groupId>com.alibaba</groupId>
        <artifactId>druid</artifactId>
        <version>1.0.14</version>
</dependency>


然后查看了它的相关依赖,果然找到了这两个依赖。 
解决方法是:pom.xml引入时排除掉这两个依赖:


<dependency>
        <groupId>com.alibaba</groupId>
        <artifactId>druid</artifactId>
        <version>1.0.14</version>
        <exclusions>
                <exclusion>  
                    <groupId>com.alibaba</groupId>
                    <artifactId>jconsole</artifactId>
                    <version>1.8.0</version>
                </exclusion>  
                <exclusion>
                    <groupId>com.alibaba</groupId>
                    <artifactId>tools</artifactId>
                    <version>1.8.0</version>
                </exclusion>
        </exclusions>
    </dependency>
参考资料:
http://bbs.csdn.net/topics/391023241
http://blog.csdn.net/nsdnresponsibility/article/details/50961613
©️2020 CSDN 皮肤主题: 猿与汪的秘密 设计师: 上身试试 返回首页
实付0元
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值